// Generated by CoffeeScript 2.2.4
var chromakey, clipping, createCrops, current, draw, drawing, drawuv, getcrops, left, newcrop, preload, selectcrop, selectingcrop, selectside, setup, squareuv, startpos, uvtocropinput, vs;

clipping = true;

vs = [];

current = null;

left = true;

startpos = new v2(0, 0);

drawing = false;

selectingcrop = false;

chromakey = null;

preload = function() {
  return chromakey = loadShader("shader/default.vert", "shader/chroma.frag");
};

newcrop = function() {
  return {
    uvs: [new uv(new v2(0, 0), new v2(0, 0)), new uv(new v2(0, 0), new v2(0, 0))],
    crop: new uv(new v2(0.23, 0.1), new v2(0.78, 0.93))
  };
};

createCrops = function() {
  var i, j, len, results, v;
  results = [];
  for (i = j = 0, len = VIDEOS.length; j < len; i = ++j) {
    v = VIDEOS[i];
    results.push(newcrop());
  }
  return results;
};

squareuv = function(x, y) {
  var h, r, w;
  w = 0.5;
  r = 16 / 9;
  h = w * r;
  x = x / innerWidth;
  y = y / (innerWidth * r);
  return new uv(new v2(x, y), new v2(x + w, y + h));
};

uvtocropinput = function(uv, w, h) {
  return {
    x: uv.a.x * w,
    y: uv.a.y * h,
    w: (uv.b.x - uv.a.x) * w,
    h: (uv.b.y - uv.a.y) * h
  };
};

getcrops = function() {
  return vs.map(function(v) {
    var c;
    c = uvtocropinput(v.crop, v.video.width, v.video.height);
    return {
      name: v.name,
      crop: `${Math.floor(c.w)}:${Math.floor(c.h)}:${Math.floor(c.x)}:${Math.floor(c.y)}`
    };
  });
};

setup = function() {
  var i, name, o, v;
  createCanvas(innerWidth, innerWidth, WEBGL);
  vs = (function() {
    var j, len, results;
    results = [];
    for (i = j = 0, len = VIDEOS.length; j < len; i = ++j) {
      name = VIDEOS[i];
      v = createVideo(`raw/cropped/${name}.mp4`);
      v.stop();
      // v.loop()
      v.hide();
      o = CROPS[i];
      o.video = v;
      o.playing = false;
      o.name = name;
      results.push(o);
    }
    return results;
  })();
  current = vs[0];
  $("canvas").mousedown(function(e) {
    var x, y;
    drawing = true;
    x = mouseX / width;
    y = mouseY / width;
    startpos = new v2(x, y);
    if (selectingcrop) {
      return current.crop = squareuv(e.offsetX, e.offsetY);
    }
  });
  return $("canvas").mouseup(function(e) {
    return drawing = false;
  });
};

drawuv = function(c, uvs) {
  push();
  fill(c);
  stroke(c);
  noFill();
  beginShape();
  vertex(uvs.a.x * width, uvs.a.y * height, 0);
  vertex(uvs.a.x * width + uvs.w * width, uvs.a.y * height, 0);
  vertex(uvs.a.x * width + uvs.w * width, uvs.a.y * height + uvs.h * height, 0);
  vertex(uvs.a.x * width, uvs.a.y * height + uvs.h * height, 0);
  endShape(CLOSE);
  return pop();
};

draw = function() {
  var currentpos, uvs;
  background("#0002");
  translate(-width * 0.5, -height * 0.5);
  chromakey.setUniform("screenColor", color(COLORS.chroma).levels.reduce((function(a, v, i) {
    if (i < 3) {
      return a.concat([v / 255]);
    } else {
      return a;
    }
  }), []));
  shader(chromakey);
  texture(current.video);
  beginShape();
  vertex(0, 0, 0, 0, 0);
  vertex(width, 0, 0, 1, 0);
  vertex(width, height, 0, 1, 1);
  vertex(0, height, 0, 0, 1);
  endShape();
  uvs = drawing ? (currentpos = new v2(mouseX / width, mouseY / width), current.uvs[(left ? 0 : 1)] = new uv(startpos, currentpos), current.uvs[(left ? 0 : 1)]) : current.uvs[(left ? 0 : 1)];
  drawuv(COLORS.left, current.uvs[0]);
  return drawuv(COLORS.right, current.uvs[1]);
};

// push()
// c = "#fff"
// fill(c)
// stroke(c)
// noFill()
// beginShape()
// vertex(current.crop.a.x * width, current.crop.a.y * height, 0)
// vertex(current.crop.a.x * width + current.crop.w * width, current.crop.a.y * height, 0)
// vertex(current.crop.a.x * width + current.crop.w * width, current.crop.a.y * height + current.crop.h * height, 0)
// vertex(current.crop.a.x * width, current.crop.a.y * height + current.crop.h * height, 0)
// endShape(CLOSE)
// pop()
$("<div>", {
  id: "#buttons",
  html: VIDEOS.map(function(v, i) {
    return $("<button>", {
      html: v,
      id: `v${i}`
    }).click(function(e) {
      var id;
      id = parseInt(e.currentTarget.id.substring(1, e.currentTarget.id.length), 10);
      console.log(id);
      if (current.playing) {
        current.playing = false;
        current.video.stop();
      }
      return current = vs[id];
    });
  })
}).appendTo($("body"));

selectcrop = function(e) {
  return selectingcrop = true;
};

selectside = function(e) {
  selectingcrop = false;
  left = e.currentTarget.innerHTML === "left";
  $(".selected").css("background-color", "#666").removeClass("selected");
  $(this).addClass("selected");
  return $(this).css("background-color", (left ? COLORS.left : COLORS.right));
};

$("<button>", {
  id: "left",
  html: "left"
}).click(selectside).appendTo($("body")).css("border", `2px solid ${COLORS.left}`);

$("<button>", {
  id: "right",
  html: "right"
}).click(selectside).appendTo($("body")).css("border", `2px solid ${COLORS.right}`);

$("<button>", {
  id: "crop",
  html: "crop"
}).click(selectcrop).appendTo($("body")).css({
  border: `2px solid ${COLORS.right}`,
  left: "100px"
});

$("<textarea>", {
  id: "output"
}).appendTo($("body"));

$("html").keyup(function(e) {
  var json;
  if (e.key === " ") {
    if (current.playing) {
      current.playing = false;
      return current.video.pause();
    } else {
      current.video.play();
      return current.playing = true;
    }
  } else if (e.key === "Enter") {
    json = JSON.stringify(vs.map(function(v) {
      return {
        uvs: v.uvs
      };
    }));
    $("#output").val(json);
    return localStorage.setItem("CROPS", json);
  }
});

//# sourceMappingURL=editor.js.map
